#!/bin/bash
# 02.05.2000 by Anton Anisimov <aa@bestlinux.net>
# Script for executing SOT Office
# Last update: 21.05.2002 by Anton Anisimov
# Change log:
# aa 17.05.2002 Now checking that soffice is SOT Office application, use whoami instead of $USER
# aa 21.05.2002 added '2>/dev/null' for cat operations to prevent error output, added checking to exact name SOT Office instead null checking, if there is no SOT Office in the list then set DefaultPath to null, now it should support long paths like "/opt/Very long path/"
# ar 08.08.2002 rewrote for SOTO R2, kept compatibility with previous version, now using .sversionrc file, cleanup obsolete parts
# TODO: we can use standart instdb.ins where DestPath instead of our own file, possibility should be checked
# Let`s keep old long path commented:
# SOTO_SEARCH_PATH="/home /usr /opt /sbin" 

SOTO_SEARCH_PATH="/usr/bin /opt"
CURRENT_USER=`whoami`

# Check that path contain exact SOT Office product
function check_SOTO_product() {
	if [ $DefaultPath  ] ; then
	INSTDB=`find $DefaultPath 2>/dev/null -user $CURRENT_USER | grep instdb.ins`
	if [ $INSTDB ]; then
		CheckSOTO=`cat $INSTDB | grep ProductName | grep "SOT Office" | sed -e s/.*"= \""// | sed s/\"\;//`
		# Here we can check exact version, now it`s not needed but anyway in future quite possible
		SOTO_Version=`cat "$PathList/program/instdb.ins" 2>/dev/null | grep ProductVersion | sed -e s/.*"= \""// | sed s/\"\;//`
		if [ -z "$CheckSOTO" ]; then DefaultPath="" ; fi
	else 
		DefaultPath="" 
	fi
	fi
}

function check_SOTO_working_path() {
DefaultPath=`cat $HOME/.sversionrc | grep "SOT Office" | sed s/".*file:\/\/"//g | sed s/
//g`
check_SOTO_product
if [ $DefaultPath ]; then WorkingPath=$DefaultPath
else
# Searching in user home path, working only for not hide directories like .something
#AA
		DefaultPath=`find $HOME -path '*/soffice' -type l -user $CURRENT_USER 2>/dev/null | sed -e 's/\/soffice//' | sed s/" "/\\\\\\\/g 3>/dev/null`
		for PathList in $DefaultPath; do			
			PathList=`echo $PathList | sed s/\\\\\\\\/" "/g`
			DefaultPath=$PathList			
			check_SOTO_product
			if [ $DefaultPath ]; then break; fi
                done
		if [ -d "$DefaultPath" ]; then
			WorkingPath="$DefaultPath"
		else
# Ok now we have more exotic case, searching in /
			DefaultPath=`find $SOTO_SEARCH_PATH -path '*/soffice' -type l -user $CURRENT_USER 2>/dev/null | sed -e 's/\/soffice//'  | sed s/" "/\\\\\\\/g  3>/dev/null`
			for PathList in $DefaultPath; do
				PathList=`echo $PathList | sed s/\\\\\\\\/" "/g`
				DefaultPath=$PathList			
				check_SOTO_product
				if [ $DefaultPath ]; then break; fi
                	done

        		if [ -d "$DefaultPath" ]; then
                		WorkingPath="$DefaultPath"
			else
# Else unable to find anything choose setup default path
				if [ -f /opt/SOTO/setup ]; then WorkingPath="/opt/SOTO/setup" ; fi
				if [ -f /opt/soto/setup ]; then WorkingPath="/opt/soto/setup" ; fi
			fi

		fi
fi
}

check_SOTO_working_path

if [ -z $WorkingPath ]; then exit 0 ; fi

SETUP=`echo $WorkingPath | sed s/".*\/"//g`

if [ $SETUP != "setup" ]; then

	CheckPath=`cat $HOME/.sversionrc | grep "SOT Office" | sed s/".*file:\/\/"//g | sed s/
//g`
# fix .sversionrc file if wrong path
	if [ -z $CheckPath ] || [ "$WorkingPath" != "$CheckPath" ]; then
			echo "Path not found in .sversionrc file or wrong"
			echo Found SOT Office in $WorkingPath
			sed /"SOT Office"/d $HOME/.sversionrc | sed s/
//g | sed /^$/d > ttt
			echo "SOT Office 2002=file://""$WorkingPath"  >> ttt
			mv -f ttt $HOME/.sversionrc
	fi
	cd $WorkingPath
	./soffice
else
	
	SETUPDIR=`echo $WorkingPath | sed s/"\/setup"//g`
	echo $SETUPDIR
	cd $SETUPDIR
	./setup
	
	CheckPath=`cat $HOME/.sversionrc | grep "SOT Office" | sed s/".*file:\/\/"//g | sed s/
//g`
	if [ -z $CheckPath ] ; then exit 0 ; fi

	A="sdraw simpress smath sweb swriter scalc"
	for loop in $A
	do 
		ln -sf $SETUPDIR/program/$loop $CheckPath/
	done	
fi


